#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_JumpCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_JumpCFG> Fish_JumpCFG::msSingleton(nullptr);

int Fish_JumpCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_JumpCFGData* Fish_JumpCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_JumpCFGData>& Fish_JumpCFG::GetMapData()
{
	return mMapData;
}

void Fish_JumpCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_JumpCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_JumpCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.m图标1 = element->Attribute("图标1");
		data.m图标2 = element->Attribute("图标2");
		data.m图标3 = element->Attribute("图标3");
		data.m图标4 = element->Attribute("图标4");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_JumpCFG::Load()
{
	Load("../Config/Fish_JumpCFG.xml");
}

Fish_JumpCFG* Fish_JumpCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_JumpCFG());
	}
	return msSingleton.get();
}
